#ifndef LN_FIFO_H
#define LN_FIFO_H

template <class T>
class FIFO
{
	protected:
		class Node
		{
			public:
				T		item;
				Node 	* next, * last;
		};

		Node * first, * last;
		
	public:
		FIFO() { first = NULL; last = NULL; };
		~FIFO() { while ( HasItems() ) { Remove(); } };
		
		void Add(const T & i)
		{
			Node * node = new Node;
			node->item = i;
			if (last)
				last->next = node;
			node->last = last;
			node->next = NULL;
			last = node;
			
			if (!first)
				first = node;
		};
		T Remove()
		{
			T t; t = first->item;
			Node * temp = first;
			first = first->next;
			if ( first == NULL )
				last = NULL;
			delete temp;
			return t;
		};
		bool HasItems()
		{
			return first != NULL;
		};
};

#endif
