#ifndef OBJECT_H
#define OBJECT_H

#include <OS.h>		// for types such as uint32

#include "LnList.h"

class Creature;

class Object
{
	public:
		Object( const char * );
		virtual ~Object();
				
		virtual void Use( Creature * target, Creature * source = NULL);
		
		uint32		id;
		char		bitmap[64];
		
		const char	* name;
		const char	* internal_name;
		
		uint32		equip; // equipment mask, Creature::HEAD and so on
		
		const char	* skill; // skill used to activate object
		
		virtual status_t Load( BFile * );
		virtual status_t Save( BFile * );
};

class ObjectInfoSet; // for load/save

class ObjectSet
{
	public:
		ObjectSet();
		~ObjectSet();
		
		void		Add( Object * );
		Object *	Find( uint32 );
		void		Clear();

		status_t Load( BFile *, ObjectInfoSet * );
		status_t Save( BFile * );
		
	protected:
		uint32			next_id;
		List<Object>	objects;
};

#endif
